<template>
  <div>
    <div @click="openDialog">
      <slot></slot>
    </div>
    <a-modal v-model="isDialogActive" centered :footer="null" :width="1100" :closeable="false">
      <div class="relative mb-8">
        <div class="absolute">
          <b-outline-action-button @click="closeDialog">Back</b-outline-action-button>
        </div>
        <div class="text-center">
          <t-h1 size="text-3xl" weight="bold">Floor: {{area.name}}</t-h1>
        </div>
      </div>
      <div class="text-center mb-6">
        <a-radio-group v-model="tab" button-style="solid">
          <a-radio-button value="visual">Visual</a-radio-button>
          <a-radio-button value="daily">Daily Population Graph</a-radio-button>
          <a-radio-button value="checkin">Check-In Information</a-radio-button>
        </a-radio-group>
      </div>
      <div v-if="tab === 'visual'" class="p-12 py-10">
        <area-visual></area-visual>
      </div>
      <div v-if="tab === 'daily'" class="p-12 py-10">
        <area-daily-population></area-daily-population>
      </div>
      <div v-if="tab === 'checkin'" class="p-12 py-10">
        <area-check-in></area-check-in>
      </div>
    </a-modal>
  </div>
</template>

<script>
import { defineComponent } from '@nuxtjs/composition-api'
import TH1 from '~/components/shared/typography/H1'
import BOutlineActionButton from '~/components/shared/buttons/OutlineActionButton'
import AreaCheckIn from '~/components/area/AreaCheckIn.vue'
import AreaDailyPopulation from '~/components/area/AreaDailyPopulation.vue'
import AreaVisual from '~/components/area/AreaVisual.vue'
import { useBuilding } from '~/store/building'

export default defineComponent({
  components: {
    BOutlineActionButton,
    TH1,
    AreaCheckIn,
    AreaVisual,
    AreaDailyPopulation,
  },
  props: { 
    area: {
      type: Object,
      required: true,
    }
  },
  setup() {
    const store = useBuilding()
    return { store }
  },
  data() {
    return {
      tab: 'visual',
      isDialogActive: false,
    }
  },
  methods: {
    openDialog() {
      this.store.onSelectArea(this.area.id)
      this.isDialogActive = true
    },
    closeDialog() {
      this.isDialogActive = false
    },
  },
})
</script>
